using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page, ICallbackEventHandler
    {
        private string returnString;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                LayerOverlay newOverlay = new LayerOverlay("NewOverlay");
                newOverlay.IsBaseOverlay = false;
                Map1.CustomOverlays.Add(newOverlay);

            }
        }

        #region ICallbackEventHandler Members

        public string GetCallbackResult()
        {
            return returnString;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            returnString = "NewOverlay";

            ShapeFileFeatureLayer shapeLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/usa/states.shp"));
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            Map1.StaticOverlay.Layers.Add(shapeLayer);

            LayerOverlay newOverlay = (LayerOverlay)Map1.CustomOverlays[returnString];

            if (!newOverlay.Layers.Contains("newLayer"))
            {
                newOverlay.Layers.Add("newLayer", shapeLayer);
            }
        }

        #endregion
    }
}
